//+--------------------------------------------------------------------+
//|Whistler Active Volatility Energy - Acceleration Map | WAVE-AM      |
//|                        Copyright 2009, MetaQuotes Software Corp.   |
//|                                  Authors: Mark Whistler/EcTrader   |
//|                                      Mark@WallStreetRockStar.com   |
//|                www.WallStreetRockStar.com / www.fxVolatility.com   |
//|                                                                    |
//+--------------------------------------------------------------------+
#property copyright "Copyright 2009, Mark Whistler/WallStreetRockStar.com"
#property link      "http://www.wallstreetrockstar.com"
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 2

#define OutColor   Green
#define InColor  Red
#define BollingerLineWidth  2
#define OutUpStyle 233
#define OutDnStyle 234
#define InUpStyle 218
#define InDnStyle 217
#define CrossStyle 251
//---- indicator parameters
extern int    LongBandsPeriod=50;
extern double LongBandsDeviations=2.2;
extern int    ShortBandsPeriod=14;
extern double ShortBandsDeviations=3.2;
extern int MaxDrawBars = 5000;
bool Longed=true;
bool Shorted=true;
//---- buffers
double LongBollUp[];
double LongBollDn[];
double LongBollMd[];
double ShortBollUp[];
double ShortBollDn[];
double ShortBollMd[];
//----------
int MarketPeriod;
int Trend;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  //---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,LongBollUp);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,LongBollDn);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LongBollMd);
//----
   SetIndexDrawBegin(0,LongBandsPeriod);
   SetIndexDrawBegin(1,LongBandsPeriod);
   SetIndexDrawBegin(2,LongBandsPeriod);
   //---- indicators
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ShortBollUp);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ShortBollDn);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ShortBollMd);
//----
   SetIndexDrawBegin(3,ShortBandsPeriod);
   SetIndexDrawBegin(4,ShortBandsPeriod);
   SetIndexDrawBegin(5,ShortBandsPeriod);
//----
   MarketPeriod=0;
   Trend=0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;

//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
     {
       LongBollMd[i]=iMA(NULL,0,LongBandsPeriod,0,MODE_SMA,PRICE_CLOSE,i);
       ShortBollMd[i]=iMA(NULL,0,ShortBandsPeriod,0,MODE_SMA,PRICE_CLOSE,i);
     }

//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      //----------------------
      sum=0.0;
      k=i+LongBandsPeriod-1;
      oldval=LongBollMd[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=LongBandsDeviations*MathSqrt(sum/LongBandsPeriod);
      LongBollUp[i]=oldval+deviation;
      LongBollDn[i]=oldval-deviation;
      //----------------------
      sum=0.0;
      k=i+ShortBandsPeriod-1;
      oldval=ShortBollMd[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=ShortBandsDeviations*MathSqrt(sum/ShortBandsPeriod);
      ShortBollUp[i]=oldval+deviation;
      ShortBollDn[i]=oldval-deviation;
      
      i--;
     }
   i=Bars-counted_bars-1;
   while(i>=0)
     {
       if (ShortBollMd[i]>LongBollMd[i] && ShortBollMd[i+1]<LongBollMd[i+1])
         {
           DrawLongCross(ShortBollMd[i],i);
           MarketPeriod=1;
           Trend=1;
         }
       else if (ShortBollMd[i]<LongBollMd[i] && ShortBollMd[i+1]>LongBollMd[i+1])
         {
           DrawShortCross(ShortBollMd[i],i);
           MarketPeriod=1;
           Trend=-1;
         }
       //---------------------------------------
        
       //if (Trend==1)
       //  {
           if (ShortBollMd[i]<LongBollMd[i])
             {
               //Trend=0;
               MarketPeriod=0;
               CleanLongCross(i);
             }
       //  }
       //else if (Trend==-1)
       //  {
           if (ShortBollMd[i]>LongBollMd[i])
             {
               //Trend=0;
               MarketPeriod=0;
               CleanShortCross(i);                
             }
       //  }
       //------------------------------------------
       if (ShortBollUp[i]>LongBollUp[i] && ShortBollUp[i+1]<LongBollUp[i+1])
         {
           DrawUp((ShortBollUp[i]+ShortBollUp[i+1])/2,i);
         }
       if (ShortBollDn[i]<LongBollDn[i] && ShortBollDn[i+1]>LongBollDn[i+1])
         {
           DrawDn((ShortBollDn[i]+ShortBollDn[i+1])/2,i);
         }
       //------------------------------------------
       if (ShortBollUp[i]<LongBollUp[i])
         {
           CleanUp(i);
         }
       if (ShortBollDn[i]>LongBollDn[i])
         {
           CleanDn(i);
         }
       //------------------------------------------
       if (ShortBollUp[i]<LongBollUp[i] && ShortBollUp[i+1]>LongBollUp[i+1])
         {
           DrawUpIn((ShortBollUp[i]+ShortBollUp[i+1])/2,i);
         }
       if (ShortBollDn[i]>LongBollDn[i] && ShortBollDn[i+1]<LongBollDn[i+1])
         {
           DrawDnIn((ShortBollDn[i]+ShortBollDn[i+1])/2,i);
         }
       //------------------------------------------
       if (ShortBollUp[i]>LongBollUp[i])
         {
           CleanUpIn(i);
         }
       if (ShortBollDn[i]<LongBollDn[i])
         {
           CleanDnIn(i);
         }
       //------------------------------------------

        i--;
     }
    return(0);
  }

int DrawLongCross(double Price, int Shift)
  {
    color CrossColor=Lime;
    double DrawPrice=Price+8*Point;
    if (Shift<MaxDrawBars)
      {DrawArrow(CrossColor, DrawPrice, CrossStyle, "MALongCross", Shift, 4);}
  }
int DrawShortCross(double Price, int Shift)
  {
    color CrossColor=Red;
    double DrawPrice=Price+8*Point;
    if (Shift<MaxDrawBars)
      {DrawArrow(CrossColor, DrawPrice, CrossStyle, "MAShortCross", Shift, 4);}
  }
int CleanLongCross(int Shift)
  {
    ObjectDelete("MALongCross Arrow"+Shift);
  }
int CleanShortCross(int Shift)
  {
    ObjectDelete("MAShortCross Arrow"+Shift);
  }
int DrawUp(double Price, int Shift)
  {
    if (Shift<MaxDrawBars)
      {DrawArrow(OutColor, Price+8*Point, OutUpStyle, "UpLine", Shift, 2);}
  }

int DrawDn(double Price, int Shift)
  {
    if (Shift<MaxDrawBars)
      {DrawArrow(OutColor, Price+12*Point, OutDnStyle, "DnLine", Shift, 2);}
  }
int DrawUpIn(double Price, int Shift)
  {
    if (Shift<MaxDrawBars)
      {DrawArrow(InColor, Price+8*Point, InUpStyle, "UpLineIn", Shift, 4);}
  }
int DrawDnIn(double Price, int Shift)
  {
    if (Shift<MaxDrawBars)
      {DrawArrow(InColor, Price+12*Point, InDnStyle, "DnLineIn", Shift, 4);}
  }
int CleanUp(int Shift)
  {
    ObjectDelete("UpLine Arrow"+Shift);
  }
int CleanDn(int Shift)
  {
    ObjectDelete("DnLine Arrow"+Shift);
  }
int CleanUpIn(int Shift)
  {
    ObjectDelete("UpLineIn Arrow"+Shift);
  }
int CleanDnIn(int Shift)
  {
    ObjectDelete("DnLineIn Arrow"+Shift);
  }
int DrawArrow(color Colors, double PriceNow, int Style, string name,int Shift, int Size)
  {
    if (ObjectFind(name+" Arrow" + Shift)==-1)
      {
        ObjectCreate(name + " Arrow"+ Shift,OBJ_ARROW,0,Time[Shift],PriceNow);
        ObjectSet(name + " Arrow"+ Shift,OBJPROP_ARROWCODE,Style);
        ObjectSet(name + " Arrow"+ Shift,OBJPROP_COLOR,Colors);
        ObjectSet(name + " Arrow"+ Shift,OBJPROP_WIDTH,Size);
      }
    else
      {
        ObjectMove(name + " Arrow"+ Shift,0, Time[Shift],PriceNow);
      }
  }


